const express = require("express")
const fs = require("fs")
const app = express()

exports.setup = function(data, port) {
  if (data.constructor.name == "Object") {
    data = data
  } else if (data.constructor.name == "String") {
    if (fs.existsSync(data) && data.endsWith(".json")) {
      data = JSON.parse(fs.readFileSync(data))
    } else {
      console.error("Error", "Invalid data")
      return;
    }
  } else {
    console.error("Error", "Invalid data")
    return;
  }
  app.use((req, res) => {
    function use(name) {
      if (data[name]["type"] == "content") {
        res.send(data[name]["value"])
        if (!!data[name]["status"] && data[name]["status"].constructor.name == 'Number'){
          res.status(data[name]["status"])
        }
      } else if (data[name]["type"] == "file") {
        if (fs.existsSync(data[name]["value"])) {
          req.sendFile(__dirname + data[name]["value"])
          if (!!data[name]["status"] && data[name]["status"].constructor.name == 'Number'){
          res.status(data[name]["status"])
        }
        } else {
          console.error("Error", "file not exist")
          return;
        }
      } else if (data[name]["type"] == "link") {
        res.redirect(data[name]["value"])
      }
    }
    if (!!data[req.path]) {
      use(req.path)
    } else if (!!data["404"]) {
      use("404")
    }
  })
  if (!!port) {
    app.listen(port)
  }
}
exports.port = function(port) {
  app.listen(port)
}